;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;              iss-            ;;
;;                 IssBuilder.            ;;
;;                                                       ;;
;;              Copyright (C) 2007 Gipat Group           ;;
;;                             ;;
;;                      LGPL v2.1                        ;;
;;                                                       ;;
;;                  www.gipatgroup.org                   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;      , ....  :
;; 1) Sagrer (sagrer@yandex.ru)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;    GGBuildTools

[Setup]
InternalCompressLevel=ultra
OutputBaseFilename=Arbuzon_1_0_1_40
SolidCompression=true
Compression=lzma/ultra
OutputDir=.\
SourceDir=.\
VersionInfoVersion=1.0.1.40
VersionInfoTextVersion=Arbuzon 1.0.1.40
VersionInfoCompany=ArbuzoLiteyniy-factory-transgalactic-megacorporation
VersionInfoDescription=Arbuzon 1.0.1.40
ShowLanguageDialog=no
AppName={code:ConstAppName}
AppVerName=Arbuzon 1.0.1.40
DefaultDirName={code:ConstInstallPath}
UsePreviousAppDir=false
DefaultGroupName={code:ConstDeveloperName}\{code:ConstAppName}\
DisableStartupPrompt=true
FlatComponentsList=true
AppendDefaultDirName=false
UsePreviousSetupType=false
AppCopyright=Copyright  30027 ArbuzoLiteyniy-factory-transgalactic-megacorporation
RestartIfNeededByRun=false
WizardImageFile=compiler:wizmodernimage-is.bmp
WizardSmallImageFile=compiler:wizmodernsmallimage-is.bmp
VersionInfoCopyright=Copyright  30027 ArbuzoLiteyniy-factory-transgalactic-megacorporation
;LicenseFile=GG_opened_EI-editor-utility_license.txt
;InfoBeforeFile=lgpl.txt
[_ISTool]
UseAbsolutePaths=false
[Languages]
Name: Russian; MessagesFile: compiler:Languages\Russian.isl
Name: English; MessagesFile: compiler:Default.isl
[Registry]
Root: HKCU; Subkey: Software\{code:ConstDeveloperName}\{code:ConstAppName}\; Flags: createvalueifdoesntexist uninsdeletekey; Components: AlwaysInstall
Root: HKCU; Subkey: Software\{code:ConstDeveloperName}\{code:ConstAppName}\; ValueType: string; ValueName: ver; ValueData: {code:ConstAppVer}; Components: AlwaysInstall
Root: HKCU; Subkey: Software\{code:ConstDeveloperName}\{code:ConstAppName}\; ValueType: string; ValueName: path; ValueData: {app}; Components: AlwaysInstall
[Components]
Name: CurrVersion_Main; Description:    ; Flags: fixed; Check: CheckDoNewInstall; Types: StandardInstall
Name: AlwaysInstall; Description:  ; Flags: fixed; Types: StandardInstall
[Types]
Name: StandardInstall; Description:  ; Languages: 
[Icons]
Name: {group}\Arbuzon; Filename: {app}\Arbuzon.exe; Components: CurrVersion_Main
Name: {group}\AlwaysUpdatableIcon; Filename: {app}\MegaFile.exe; Components: AlwaysInstall
Name: {group}\readme.txt; Filename: {app}\readme.txt; Components: CurrVersion_Main
Name: {group}\; Filename: {uninstallexe}; Components: CurrVersion_Main
[Code]
const
  AppName = 'Arbuzon';   //  
  AppVer = '1.0.1.40';
  NoFullInstall = false;   //\  
  NoUpdate = true;       //\ 
  UpdateFrom = '0.0.0.1;0.0.0.2';     //,    .
  DeveloperName = 'ArbuzoLiteyniy-factory-transgalactic-megacorporation';    //  -    .

var
  InstallPath, CurrentVer : string;
  DoNewInstall, DoUpdate : boolean;

Function Parse (Str, Separator : string; Var Parsed : string) : string;
var
  I, StrLength : integer;
begin
  //   . ,    :(.
  I := 0;
  StrLength := Length(Str);
  if StrLength > 0 then begin
    Parsed := '';

    repeat
      I := I+1;
      If Str[I] <> Separator then begin
        //    -  .
        Parsed := Parsed+Str[I];
      end;
    until (I = StrLength) or (Str[I] = Separator);

    Result := Str;
    Delete(Result,1,I);
  end
  else begin
    Parsed := Str;
    Result := '';
  end;
end;

Function IsNumericStr (Str : string) : boolean;
var
  I, StrLength : integer;
  FindedChar : boolean;
begin
  //    ,      .

  Result := true;  // .

  StrLength := Length(Str);
  If StrLength > 0 then begin
    //       .
    For I := 1 to StrLength do begin
      FindedChar := true;
      If Str[I] = '1' then FindedChar := false;  //  1  -      :)
      If Str[I] = '2' then FindedChar := false;
      If Str[I] = '3' then FindedChar := false;
      If Str[I] = '4' then FindedChar := false;
      If Str[I] = '5' then FindedChar := false;
      If Str[I] = '6' then FindedChar := false;
      If Str[I] = '7' then FindedChar := false;
      If Str[I] = '8' then FindedChar := false;
      If Str[I] = '9' then FindedChar := false;
      If Str[I] = '0' then FindedChar := false;

      //    -  -   .
      If FindedChar = true then Result := false;
    end;
  end
  else begin
    Result := false;  //  .
  end;
end;

Function IsVersionStr (Str : string) : boolean;
var
  I, StrLength : integer;
  FindedChar, WasPoint : boolean;
begin
  //    ,      .

  Result := true;  // .

  StrLength := Length(Str);
  If StrLength > 0 then begin
    //       .
    WasPoint := false;
    For I := 1 to StrLength do begin
      FindedChar := true;
      If Str[I] = '1' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '2' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '3' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '4' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '5' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '6' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '7' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '8' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '9' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '0' then begin
        FindedChar := false;
        WasPoint := false;
      end;
      If Str[I] = '.' then begin
        FindedChar := false;
        If WasPoint = true then begin
          //      -  .
          FindedChar := true;
        end;
        WasPoint := true;
      end;

      //    -     -   .
      If FindedChar = true then Result := false;
    end;
  end
  else begin
    Result := false;  //  .
  end;
end;

Function IsNewVersion(InstalledVer, CurrentVer : string) : boolean;
var
  CurrVerLevels, I,
  InstalledVerLevels, MaxLevel : integer;
  TempStr, TempStr2,
  InstalledVerTemp, CurrentVerTemp : string;
begin
  //  ,       .

  Result := false;  //  .
  InstalledVerTemp := InstalledVer;
  CurrentVerTemp := CurrentVer;


  If (IsVersionStr(InstalledVer) = true) and (IsVersionStr(CurrentVer) = true) then begin
    //     - .

    //  -       .
    TempStr := CurrentVerTemp;
    CurrVerLevels := 1;  //   1 .
    repeat
      If Pos('.',TempStr) <> 0 then begin
        CurrVerLevels := CurrVerLevels + 1;   //   1 .
        TempStr := Parse(TempStr,'.',TempStr2);
      end;
    until Pos('.',TempStr) = 0;

    //  .
    TempStr := InstalledVerTemp;
    InstalledVerLevels := 1;  //   1 .
    repeat
      If Pos('.',TempStr) <> 0 then begin
        InstalledVerLevels := InstalledVerLevels + 1;   //   1 .
        TempStr := Parse(TempStr,'.',TempStr2);
      end;
    until Pos('.',TempStr) = 0;

    //   .
    If CurrVerLevels > InstalledVerLevels then begin
      MaxLevel := CurrVerLevels;
    end
    else begin
      MaxLevel := InstalledVerLevels;
    end;

    // -       -  .
    If CurrVerLevels < MaxLevel then begin
      For I := 1 to MaxLevel - CurrVerLevels do begin
        CurrentVerTemp := CurrentVerTemp+'.0';
      end;
    end;
    If InstalledVerLevels < MaxLevel then begin
      For I := 1 to MaxLevel - InstalledVerLevels do begin
        InstalledVerTemp := InstalledVerTemp+'.0';
      end;
    end;

    //   -   .
    I := 0;
    repeat
      I := I+1;
      InstalledVerTemp := Parse(InstalledVerTemp,'.',TempStr);
      CurrentVerTemp := Parse(CurrentVerTemp,'.',TempStr2);
      If StrToInt(TempStr2) > StrToInt(TempStr) then Result := true;
    until (I = MaxLevel) or (Result = true);
  end;
end;

Function VersionIsUpdatable(Version : string) : boolean;
// -          
var
  ParsedStr, CheckableVer : string;
begin
  //
  Result := false;

  // .
  ParsedStr := UpdateFrom;
  repeat
    ParsedStr := Parse(ParsedStr,';',CheckableVer);
    if CheckableVer <> '' then begin
      if CheckableVer = Version then begin
        //, ,    .
        Result := true;
      end;
    end;
  until (ParsedStr = '') or (Result = true);

end;

Function InitializeSetup() : boolean;
var
  AllOk, TempBool : boolean;
  TempStr, TempVersionsStr, CheckableVer : string;
  ResultCode : integer;

begin
  // , ! :))))
  //MsgBox(' ',mbError,MB_OK);

  AllOk := true;  //      .

  DoNewInstall := false;
  DoUpdate := false;
  CurrentVer := '';

  //    ?
  If RegValueExists(HKEY_CURRENT_USER,'Software\'+DeveloperName+'\'+AppName,'ver') = true then begin
    //   - 
    // -          ?
    //   .
    RegQueryStringValue(HKEY_CURRENT_USER,'Software\'+DeveloperName+'\'+AppName,'ver',TempStr);
    if TempStr = AppVer then begin
      //  .    -   ?
      if MsgBox(',     ('+AppVer+')     .     -  -     .  ?',mbConfirmation,MB_YESNO) = IDNO then begin
        //   .
        AllOk := false;
      end;
    end;

    If (NoUpdate = false) and (AllOk = true) then begin
      //  

      //  -        .
      TempVersionsStr := UpdateFrom;
      TempBool := false;    // -     .
      repeat
        TempVersionsStr := Parse(TempVersionsStr,';',CheckableVer);
        if CheckableVer <> '' then begin
          if CheckableVer = TempStr then begin
            //.
            TempBool := true;
          end;
        end;
      until (TempVersionsStr = '') or (TempBool = true);

      if TempBool = true then begin
        //  -  .
        DoUpdate := true;  // .
        RegQueryStringValue(HKEY_CURRENT_USER,'Software\'+DeveloperName+'\'+AppName,'path',TempStr);
        InstallPath := TempStr;
        CurrentVer := CheckableVer;
      end
      else begin
        //   .        
        //.    .
      end;
    end
    else begin
      //  - ,   .
      //  ,  ,      
      //    .
    end;
  end;

  //    ?
  If (AllOk = true) and ((RegValueExists(HKEY_CURRENT_USER,'Software\'+DeveloperName+'\'+AppName,'ver') = false) or (DoUpdate = false)) and (NoFullInstall = false) then begin
    // .
    DoNewInstall := true;
    // -       ?
    if RegValueExists(HKEY_CURRENT_USER,'Software\'+DeveloperName+'\'+AppName,'ver') = true then begin
      // .    ,     .    
      // .     ,       ,  
      //    .       .
      RegQueryStringValue(HKEY_CURRENT_USER,'Software\'+DeveloperName+'\'+AppName,'path',TempStr);
      If DirExists(TempStr) = true then begin
        // .   .
        //       .
        TempStr := '';
        if RegValueExists(HKEY_LOCAL_MACHINE,'Software\Microsoft\Windows\CurrentVersion\Uninstall\'+AppName+'_is1','UninstallString') = true then begin
          //   .
          RegQueryStringValue(HKEY_LOCAL_MACHINE,'Software\Microsoft\Windows\CurrentVersion\Uninstall\'+AppName+'_is1','UninstallString',TempStr);
          //  -  '"'  .
          TempStr := RemoveQuotes(TempStr);
        end;
        //  -    .
        if FileExists(TempStr) = true then begin
          //      .
          if MsgBox('   .     -    .  .  ?',mbConfirmation,MB_YESNO) = IDYES then begin
            // ,   .
            Exec(TempStr,'','',SW_SHOW,ewWaitUntilTerminated,ResultCode);
            // "" 5     .
            Sleep(5000);
            //        -          
            //  .    ,      .
            if FileExists(TempStr) = true then begin
              MsgBox('   -   .       !!!',mbError,MB_OK);
            end;
            //  ,   ...
            if FileExists(TempStr) = false then begin
              //   .    ,     
              //.
            end
            else begin
              MsgBox('     .   ,     '+ExtractFilePath(TempStr)+'      .',mbError,MB_OK);
              DoNewInstall := false;
            end;
          end
          else begin
            //   .
            // .
            MsgBox('  .   ,     '+ExtractFilePath(TempStr)+'      .',mbError,MB_OK);
            DoNewInstall := false;
          end;
        end
        else begin
          //  ,        -  
          //    .
          //     .
          RegQueryStringValue(HKEY_CURRENT_USER,'Software\'+DeveloperName+'\'+AppName,'path',TempStr);
          if MsgBox('   ,   .        '+TempStr+'      .   -      (    ).  ?',mbConfirmation,MB_YESNO) = IDYES then begin
            //    ...    -      .
          end
          else begin
            //  .
            DoNewInstall := false;
          end;
        end;
      end
      else begin
        //   .        - -      ,
        //          .
      end;
    end;

    //    .
    If DoNewInstall = true then begin
      //   .
      if RegValueExists(HKEY_CURRENT_USER,'Software\'+DeveloperName+'\'+AppName,'path') = true then begin
        //       -  .
        RegQueryStringValue(HKEY_CURRENT_USER,'Software\'+DeveloperName+'\'+AppName,'path',InstallPath);
      end
      else begin
        //     -   ProgramFiles.
        InstallPath := AddBackslash(ExpandConstant('{pf}'))+'\'+DeveloperName+'\'+AppName;
      end;
      DoNewInstall:= true;
    end
    else begin
      //   - .
      AllOk := false;
    end;
  end
  else begin
    //   .  .     -      ,
    //   .
    if (DoUpdate = false) and (AllOk = true) then begin
      MsgBox('      ,     .  ,        - .    .        ,           -   .',mbError,MB_OK);
      AllOk := false;
    end;
  end;

  If AllOk = true then begin
    //  .
    Result := true;
  end
  else begin
    //  .    :(.
    //MsgBox('  :(',mbError,MB_OK);
    Result := false;
  end;
end;


Function ConstInstallPath(Default : string) : string;
begin
  Result := InstallPath;
end;

Function ConstAppVer(Default : string) : string;
begin
  Result := AppVer;
end;

Function ConstAppName(Default : string) : string;
begin
  Result := AppName;
end;

Function ConstUninstallExe(Default : string) : string;
begin
  Result := '';
  if RegValueExists(HKEY_LOCAL_MACHINE,'\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\'+AppName+'_is1','UninstallString') = true then begin
    RegQueryStringValue(HKEY_LOCAL_MACHINE,'\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\'+AppName+'_is1','UninstallString',Result);
    Result := RemoveQuotes(Result);
  end;
end;

Function ConstAppVerName(Default : string) : string;
begin
  Result := AppName+' '+AppVer;
end;

Function ConstDeveloperName(Default : string) : string;
begin
  Result := DeveloperName;
end;

Function CheckDoNewInstall() : boolean;
begin
  Result := DoNewInstall;
end;

Function CheckDoUpdate() : boolean;
begin
  Result := DoUpdate;
end;

//Function CheckUpdate_0_0_0_1() : boolean;
////- -      -       .
//begin
//  Result := VersionIsUpdatable('0.0.0.1');
//end;

Function ShouldSkipPage(CurPage: Integer) : boolean;
begin
  //   "".
  Result := false;
  //MsgBox(IntToStr(CurPage),mbError,MB_OK);
  If DoUpdate = true then begin
    //MsgBox('It is update!',mbError,MB_OK);
    //  
    If CurPage = 2 then begin
      //    -     -      .
      Result := true;
    end;
    If CurPage = 6 then begin
      //    .
      If DirExists(InstallPath) = true then begin
        //   
        //      .
        Result := true;
      end;
    end;
    If CurPage = 7 then begin
      //      -      "".
      Result := true;
    end;
    If CurPage = 8 then begin
      //       
      Result := true;
    end;
  end;
  If DoNewInstall = true then begin
    //   .
    If CurPage = 7 then begin
      //      -      "".
      Result := true;
    end;
  end;
end;



